Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue.cpp	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue.cpp	(revision 131)
@@ -70,20 +70,16 @@
     if (usage_is_set(_usage,USE_SYSTEMC))
       {
-    // Constant
-//     PORT_WRITE(out_CONST_0 ,0);
-//     PORT_WRITE(out_CONST_1 ,1);
-        for (uint32_t i=0; i<_param->_nb_ooo_engine; ++i)
-          {
-            for (uint32_t j=0; j<_param->_nb_gpr_write; ++j)
-              PORT_WRITE(out_GPR_WRITE_STATUS_DATA [i][j],1);
-            for (uint32_t j=0; j<_param->_nb_spr_write; ++j)
-              PORT_WRITE(out_SPR_WRITE_STATUS_DATA [i][j],1);
-
-            for (uint32_t j=0; j<_param->_nb_inst_insert_rob[i]; ++j)
-              {
-                PORT_WRITE(out_INSERT_ROB_GPR_STATUS_DATA [i][j],0);
-                PORT_WRITE(out_INSERT_ROB_SPR_STATUS_DATA [i][j],0);
-              }
-          }
+#ifdef SYSTEMCASS_SPECIFIC
+        constant();
+#else
+    log_printf(INFO,Register_unit_Glue,FUNCTION,"Method - constant");
+
+    SC_METHOD (constant);
+//     dont_initialize ();
+
+#ifdef SYSTEMCASS_SPECIFIC
+    // List dependency information
+#endif    
+#endif
 
     log_printf(INFO,Register_unit_Glue,FUNCTION,"Method - transition");
@@ -91,5 +87,5 @@
     SC_METHOD (transition);
     dont_initialize ();
-    sensitive_pos << *(in_CLOCK);
+    sensitive << (*(in_CLOCK)).pos();
 
 #ifdef SYSTEMCASS_SPECIFIC
@@ -101,5 +97,5 @@
     SC_METHOD (genMealy_gpr_read);
     dont_initialize ();
-//     sensitive_neg << *(in_CLOCK);
+//     sensitive << (*(in_CLOCK)).neg();
     for (uint32_t j=0; j<_param->_nb_gpr_read; j++)
       {
@@ -138,5 +134,5 @@
     SC_METHOD (genMealy_gpr_read_status);
     dont_initialize ();
-//     sensitive_neg << *(in_CLOCK);
+//     sensitive << (*(in_CLOCK)).neg();
     for (uint32_t j=0; j<_param->_nb_gpr_read; j++)
       {
@@ -167,5 +163,5 @@
     SC_METHOD (genMealy_gpr_read_registerfile);
     dont_initialize ();
-//     sensitive_neg << *(in_CLOCK);
+//     sensitive << (*(in_CLOCK)).neg();
     for (uint32_t j=0; j<_param->_nb_gpr_read; j++)
       {
@@ -196,5 +192,5 @@
     SC_METHOD (genMealy_gpr_write);
     dont_initialize ();
-//     sensitive_neg << *(in_CLOCK);
+//     sensitive << (*(in_CLOCK)).neg();
     for (uint32_t j=0; j<_param->_nb_gpr_write; j++)
       {
@@ -226,5 +222,5 @@
     SC_METHOD (genMealy_gpr_write_status);
     dont_initialize ();
-//     sensitive_neg << *(in_CLOCK);
+//     sensitive << (*(in_CLOCK)).neg();
     for (uint32_t j=0; j<_param->_nb_gpr_write; j++)
       {
@@ -255,5 +251,5 @@
     SC_METHOD (genMealy_gpr_write_registerfile);
     dont_initialize ();
-//     sensitive_neg << *(in_CLOCK);
+//     sensitive << (*(in_CLOCK)).neg();
     for (uint32_t j=0; j<_param->_nb_gpr_write; j++)
       {
@@ -284,5 +280,5 @@
     SC_METHOD (genMealy_spr_read);
     dont_initialize ();
-//     sensitive_neg << *(in_CLOCK);
+//     sensitive << (*(in_CLOCK)).neg();
     for (uint32_t j=0; j<_param->_nb_spr_read; j++)
       {
@@ -321,5 +317,5 @@
     SC_METHOD (genMealy_spr_read_status);
     dont_initialize ();
-//     sensitive_neg << *(in_CLOCK);
+//     sensitive << (*(in_CLOCK)).neg();
     for (uint32_t j=0; j<_param->_nb_spr_read; j++)
       {
@@ -350,5 +346,5 @@
     SC_METHOD (genMealy_spr_read_registerfile);
     dont_initialize ();
-//     sensitive_neg << *(in_CLOCK);
+//     sensitive << (*(in_CLOCK)).neg();
     for (uint32_t j=0; j<_param->_nb_spr_read; j++)
       {
@@ -379,5 +375,5 @@
     SC_METHOD (genMealy_spr_write);
     dont_initialize ();
-//     sensitive_neg << *(in_CLOCK);
+//     sensitive << (*(in_CLOCK)).neg();
     for (uint32_t j=0; j<_param->_nb_spr_write; j++)
       {
@@ -409,5 +405,5 @@
     SC_METHOD (genMealy_spr_write_status);
     dont_initialize ();
-//     sensitive_neg << *(in_CLOCK);
+//     sensitive << (*(in_CLOCK)).neg();
     for (uint32_t j=0; j<_param->_nb_spr_write; j++)
       {
@@ -438,5 +434,5 @@
     SC_METHOD (genMealy_spr_write_registerfile);
     dont_initialize ();
-//     sensitive_neg << *(in_CLOCK);
+//     sensitive << (*(in_CLOCK)).neg();
     for (uint32_t j=0; j<_param->_nb_spr_write; j++)
       {
@@ -467,5 +463,5 @@
     SC_METHOD (genMealy_insert);
     dont_initialize ();
-//     sensitive_neg << *(in_CLOCK);
+//     sensitive << (*(in_CLOCK)).neg();
     for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
       {
@@ -503,5 +499,5 @@
 //     SC_METHOD (genMealy_retire);
 //     dont_initialize ();
-// //     sensitive_neg << *(in_CLOCK);
+// //     sensitive << (*(in_CLOCK)).neg();
 //     for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
 //       {
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_constant.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_constant.cpp	(revision 131)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_constant.cpp	(revision 131)
@@ -0,0 +1,53 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/include/Register_unit_Glue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_execute_loop {
+namespace execute_loop {
+namespace register_unit {
+namespace register_unit_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Register_unit_Glue::constant"
+  void Register_unit_Glue::constant (void)
+  {
+    log_begin(Register_unit_Glue,FUNCTION);
+
+//  PORT_WRITE(out_CONST_0 ,0);
+//  PORT_WRITE(out_CONST_1 ,1);
+    for (uint32_t i=0; i<_param->_nb_ooo_engine; ++i)
+      {
+        for (uint32_t j=0; j<_param->_nb_gpr_write; ++j)
+          PORT_WRITE(out_GPR_WRITE_STATUS_DATA [i][j],1);
+        for (uint32_t j=0; j<_param->_nb_spr_write; ++j)
+          PORT_WRITE(out_SPR_WRITE_STATUS_DATA [i][j],1);
+        
+        for (uint32_t j=0; j<_param->_nb_inst_insert_rob[i]; ++j)
+          {
+            PORT_WRITE(out_INSERT_ROB_GPR_STATUS_DATA [i][j],0);
+            PORT_WRITE(out_INSERT_ROB_SPR_STATUS_DATA [i][j],0);
+          }
+      }
+
+    log_end(Register_unit_Glue,FUNCTION);
+  };
+
+}; // end namespace register_unit_glue
+}; // end namespace register_unit
+}; // end namespace execute_loop
+}; // end namespace multi_execute_loop
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/SelfTest/include/test.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/SelfTest/include/test.h	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/SelfTest/include/test.h	(revision 131)
@@ -15,6 +15,10 @@
 #include <sys/time.h>
 
+#define NB_ITERATION  128
+#define CYCLE_MAX     (128*NB_ITERATION)
+
+#include "Common/include/Time.h"
+#include "Common/include/Test.h"
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/include/Register_unit.h"
-#include "Common/include/Time.h"
 
 using namespace std;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/SelfTest/src/main.cpp	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/SelfTest/src/main.cpp	(revision 131)
@@ -85,4 +85,5 @@
     _nb_inst_retire_rob  [i] = atoi(argv[x++]);
   
+  int _return = EXIT_SUCCESS;
   try 
     {
@@ -114,14 +115,22 @@
   catch (morpheo::ErrorMorpheo & error)
     {
-      cout << "<" << name << "> : " <<  error.what ();
-      exit (EXIT_FAILURE);
-    }
-  catch (...)
-    {
-      cerr << "<" << name << "> : This test must generate a error" << endl;
-      exit (EXIT_FAILURE);
+      msg (_("<%s> :\n%s"),name.c_str(), error.what ());
+      _return = EXIT_FAILURE;
     }
 
-  return (EXIT_SUCCESS);
+  try 
+    {
+      if (_return == EXIT_SUCCESS)
+        TEST_OK("OOO_Engine : no error");
+      else
+        TEST_KO("OOO_Engine : a lot of error");
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+//       msg (_("<%s> :\n%s"),name.c_str(), error.what ());
+      _return = EXIT_FAILURE;
+    }
+
+  return (_return);
 }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/SelfTest/src/test.cpp	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/SelfTest/src/test.cpp	(revision 131)
@@ -7,9 +7,5 @@
  */
 
-#define NB_ITERATION  1
-#define CYCLE_MAX     (10240*NB_ITERATION)
-
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/SelfTest/include/test.h"
-#include "Common/include/Test.h"
 
 void test (string name,
@@ -22,9 +18,5 @@
 #endif
 
-  _model.set_model(NAME_Register_unit            ,MODEL_SYSTEMC, true);
-  _model.set_model(NAME_RegisterFile             ,MODEL_SYSTEMC, true);
-  _model.set_model(NAME_RegisterFile_Monolithic  ,MODEL_SYSTEMC, true);
-  _model.set_model(NAME_RegisterFile_Multi_Banked,MODEL_SYSTEMC, true);
-  _model.set_model(NAME_Register_unit_Glue       ,MODEL_SYSTEMC, true);
+  _model.set_model(MODEL_SYSTEMC,true);
 
   Tusage_t _usage = USE_ALL;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/include/Register_unit.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/include/Register_unit.h	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/include/Register_unit.h	(revision 131)
@@ -119,4 +119,10 @@
   protected : morpheo::behavioural::generic::registerfile::RegisterFile::RegisterFile ** component_spr       ;
   protected : morpheo::behavioural::generic::registerfile::RegisterFile::RegisterFile ** component_spr_status;
+
+//   protected : morpheo::behavioural::generic::registerfile::registerfile_multi_banked::RegisterFile_Multi_Banked::RegisterFile_Multi_Banked ** component_gpr       ;
+//   protected : morpheo::behavioural::generic::registerfile::registerfile_monolithic  ::RegisterFile_Monolithic  ::RegisterFile_Monolithic   ** component_gpr_status;
+//   protected : morpheo::behavioural::generic::registerfile::registerfile_multi_banked::RegisterFile_Multi_Banked::RegisterFile_Multi_Banked ** component_spr       ;
+//   protected : morpheo::behavioural::generic::registerfile::registerfile_monolithic  ::RegisterFile_Monolithic  ::RegisterFile_Monolithic   ** component_spr_status;
+
   protected : morpheo::behavioural::core::multi_execute_loop::execute_loop::register_unit::register_unit_glue::Register_unit_Glue::Register_unit_Glue      * component_glue      ;
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit.cpp	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit.cpp	(revision 131)
@@ -77,5 +77,5 @@
     SC_METHOD (transition);
     dont_initialize ();
-    sensitive_pos << *(in_CLOCK);
+    sensitive << (*(in_CLOCK)).pos();
 //#endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_allocation.cpp	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit_allocation.cpp	(revision 131)
@@ -106,5 +106,5 @@
     }
 
-    // ~~~~~[ Interface "insert_rob" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    // ~~~~~[ Interface "insert_rob" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
       ALLOC2_INTERFACE_BEGIN("insert_rob",IN,WEST,_("Interface to update status (insert)"),_param->_nb_ooo_engine,_param->_nb_inst_insert_rob [it1]);
@@ -179,4 +179,9 @@
     component_spr        = new morpheo::behavioural::generic::registerfile::RegisterFile::RegisterFile * [_param->_nb_ooo_engine];
     component_spr_status = new morpheo::behavioural::generic::registerfile::RegisterFile::RegisterFile * [_param->_nb_ooo_engine];
+
+//     component_gpr        = new morpheo::behavioural::generic::registerfile::registerfile_multi_banked::RegisterFile_Multi_Banked::RegisterFile_Multi_Banked * [_param->_nb_ooo_engine];
+//     component_gpr_status = new morpheo::behavioural::generic::registerfile::registerfile_monolithic  ::RegisterFile_Monolithic  ::RegisterFile_Monolithic   * [_param->_nb_ooo_engine];
+//     component_spr        = new morpheo::behavioural::generic::registerfile::registerfile_multi_banked::RegisterFile_Multi_Banked::RegisterFile_Multi_Banked * [_param->_nb_ooo_engine];
+//     component_spr_status = new morpheo::behavioural::generic::registerfile::registerfile_monolithic  ::RegisterFile_Monolithic  ::RegisterFile_Monolithic   * [_param->_nb_ooo_engine];
      
     for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
@@ -185,10 +190,11 @@
         log_printf(INFO,Register_unit,FUNCTION,_("Create   : %s"),name.c_str());
 
-	component_gpr        [i] = new morpheo::behavioural::generic::registerfile::RegisterFile::RegisterFile 
+ 	component_gpr [i] = new morpheo::behavioural::generic::registerfile::RegisterFile::RegisterFile 
+//  	component_gpr [i] = new morpheo::behavioural::generic::registerfile::registerfile_multi_banked::RegisterFile_Multi_Banked::RegisterFile_Multi_Banked
 	  (name.c_str()
 #ifdef STATISTICS
 	   ,param_statistics
 #endif
-	   ,_param->_param_gpr [i]
+ 	   ,_param->_param_gpr [i]//->_param_registerfile_multi_banked
 	   ,_usage
 	   );
@@ -207,10 +213,11 @@
         log_printf(INFO,Register_unit,FUNCTION,_("Create   : %s"),name.c_str());
 
-	component_gpr_status [i] = new morpheo::behavioural::generic::registerfile::RegisterFile::RegisterFile
+ 	component_gpr_status [i] = new morpheo::behavioural::generic::registerfile::RegisterFile::RegisterFile 
+// 	component_gpr_status [i] = new morpheo::behavioural::generic::registerfile::registerfile_monolithic  ::RegisterFile_Monolithic  ::RegisterFile_Monolithic
 	  (name.c_str()
 #ifdef STATISTICS
 	   ,param_statistics
 #endif
-	   ,_param->_param_gpr_status [i]
+ 	   ,_param->_param_gpr_status [i]//->_param_registerfile_monolithic
 	   ,_usage
 	   );
@@ -229,10 +236,11 @@
         log_printf(INFO,Register_unit,FUNCTION,_("Create   : %s"),name.c_str());
 	 
-	component_spr        [i] = new morpheo::behavioural::generic::registerfile::RegisterFile::RegisterFile 
+ 	component_spr [i] = new morpheo::behavioural::generic::registerfile::RegisterFile::RegisterFile
+// 	component_spr [i] = new morpheo::behavioural::generic::registerfile::registerfile_multi_banked::RegisterFile_Multi_Banked::RegisterFile_Multi_Banked
 	  (name.c_str()
 #ifdef STATISTICS
 	   ,param_statistics
 #endif
-	   ,_param->_param_spr [i]
+ 	   ,_param->_param_spr [i]//->_param_registerfile_multi_banked
 	   ,_usage
 	   );
@@ -250,10 +258,11 @@
         log_printf(INFO,Register_unit,FUNCTION,_("Create   : %s"),name.c_str());
 
-	component_spr_status [i] = new morpheo::behavioural::generic::registerfile::RegisterFile::RegisterFile
+ 	component_spr_status [i] = new morpheo::behavioural::generic::registerfile::RegisterFile::RegisterFile
+// 	component_spr_status [i] = new morpheo::behavioural::generic::registerfile::registerfile_monolithic::RegisterFile_Monolithic::RegisterFile_Monolithic
 	  (name.c_str()
 #ifdef STATISTICS
 	   ,param_statistics
 #endif
-	   ,_param->_param_spr_status [i]
+ 	   ,_param->_param_spr_status [i]//->_param_registerfile_monolithic
 	   ,_usage
 	   );
@@ -269,29 +278,33 @@
       }
 
-
-    name = _name+"_glue";
-    log_printf(INFO,Register_unit,FUNCTION,_("Create   : %s"),name.c_str());
-     
-    component_glue       = new morpheo::behavioural::core::multi_execute_loop::execute_loop::register_unit::register_unit_glue::Register_unit_Glue::Register_unit_Glue     
-      (name.c_str()
+    {
+      name = _name+"_glue";
+      log_printf(INFO,Register_unit,FUNCTION,_("Create   : %s"),name.c_str());
+      
+      component_glue = new morpheo::behavioural::core::multi_execute_loop::execute_loop::register_unit::register_unit_glue::Register_unit_Glue::Register_unit_Glue     
+        (name.c_str()
 #ifdef STATISTICS
-       ,param_statistics
-#endif
-       ,_param->_param_glue
-       ,_usage
-       );
-
-    _component->set_component (component_glue->_component
-#ifdef POSITION
-			       , 50
-			       , 50
-			       , 10
-			       , 10
-#endif
-			       );
+         ,param_statistics
+#endif
+         ,_param->_param_glue
+         ,_usage
+         );
+      
+      _component->set_component (component_glue->_component
+#ifdef POSITION
+                                 , 50
+                                 , 50
+                                 , 10
+                                 , 10
+#endif
+                                 );
+    }
      
     // ~~~~~[ Instanciation ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
     std::string src,dest;
-    
+
+    // -------------------------------------------------------------------    
+    // -----[ gpr ]-------------------------------------------------------    
+    // -------------------------------------------------------------------    
     for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
       {
@@ -300,4 +313,5 @@
         log_printf(INFO,Register_unit,FUNCTION,_("Instance : %s"),src.c_str());
 	
+        // -----[ instance "" ]-----------------------------------------------    
         {
           dest = _name;
@@ -310,4 +324,5 @@
         }
 
+        // -----[ instance "read" ]-------------------------------------------    
 	for (uint32_t j=0; j<_param->_nb_gpr_read; j++)
 	  {
@@ -332,4 +347,5 @@
 	  }
 
+        // -----[ instance "write" ]------------------------------------------    
 	for (uint32_t j=0; j<_param->_nb_gpr_write; j++)
 	  {
@@ -353,7 +369,9 @@
                                      dest, "in_GPR_WRITE_"+toString(j)+"_DATA");
 	  }
-
       }// gpr
     
+    // -------------------------------------------------------------------    
+    // -----[ gpr_status ]------------------------------------------------
+    // -------------------------------------------------------------------    
     {
       for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
@@ -401,5 +419,5 @@
               
 #ifdef POSITION
-              _component->interface_map (src ,    "write_"+toString(j),
+              _component->interface_map (src ,    "write_"+toString(x),
                                          dest,"gpr_write_status_"+toString(i)+"_"+toString(j));
 #endif
@@ -445,8 +463,10 @@
               x++;
 	    }
-
 	}
     }// gpr_status
 
+    // -------------------------------------------------------------------    
+    // -----[ spr ]-------------------------------------------------------
+    // -------------------------------------------------------------------    
     for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
       {
@@ -508,7 +528,9 @@
                                      dest, "in_SPR_WRITE_"+toString(j)+"_DATA");
 	  }
-
       }// spr
     
+    // -------------------------------------------------------------------    
+    // -----[ spr_status ]------------------------------------------------
+    // -------------------------------------------------------------------    
     {
       for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
@@ -556,5 +578,5 @@
               
 #ifdef POSITION
-              _component->interface_map (src ,    "write_"+toString(j),
+              _component->interface_map (src ,    "write_"+toString(x),
                                          dest,"spr_write_status_"+toString(i)+"_"+toString(j));
 #endif
@@ -581,5 +603,5 @@
               
 #ifdef POSITION
-              _component->interface_map (src ,    "write_"+toString(j),
+              _component->interface_map (src ,    "write_"+toString(x),
                                          dest,"insert_rob_spr_status_"+toString(i)+"_"+toString(j));
 #endif
@@ -592,5 +614,5 @@
                                        dest,"out_INSERT_ROB_SPR_STATUS_"+toString(i)+"_"+toString(j)+"_DATA");
 //                                     dest,"out_CONST_0");
-              
+
               dest = _name;
               
@@ -600,9 +622,10 @@
               x++;
 	    }
-
-
 	}
     }// spr_status
 
+    // -------------------------------------------------------------------    
+    // -----[ glue ]------------------------------------------------------
+    // -------------------------------------------------------------------    
     {
       src = _name+"_glue";
@@ -730,5 +753,5 @@
       for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
 	{
-	  uint32_t x     =_param->_nb_inst_insert_rob [i];
+	  uint32_t x = _param->_nb_inst_insert_rob [i];
 
 	  for (uint32_t j=0; j<x; j++)
@@ -758,5 +781,4 @@
 	    }
 	}
-      
     }// glue
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/include/test.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/include/test.h	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/include/test.h	(revision 131)
@@ -15,6 +15,9 @@
 #include <sys/time.h>
 
+#define NB_ITERATION  128
+#define CYCLE_MAX     (128*NB_ITERATION)
+
 #include "Common/include/Time.h"
-#include "Behavioural/include/Selftest.h"
+#include "Common/include/Test.h"
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/include/Execute_loop.h"
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/main.cpp	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/main.cpp	(revision 131)
@@ -315,4 +315,5 @@
     num_thread_valid [i] = true;
 
+  int _return = EXIT_SUCCESS;
   try 
     {
@@ -383,11 +384,19 @@
   catch (morpheo::ErrorMorpheo & error)
     {
-      msg (_("%s\n"),error.what ());
-      exit (EXIT_FAILURE);
-    }
-  catch (...)
-    {
-      err (_("This test must generate a error.\n"));
-      exit (EXIT_FAILURE);
+      msg (_("<%s> :\n%s"),name.c_str(), error.what ());
+      _return = EXIT_FAILURE;
+    }
+
+  try 
+    {
+      if (_return == EXIT_SUCCESS)
+        TEST_OK("OOO_Engine : no error");
+      else
+        TEST_KO("OOO_Engine : a lot of error");
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+//       msg (_("<%s> :\n%s"),name.c_str(), error.what ());
+      _return = EXIT_FAILURE;
     }
 
@@ -450,5 +459,5 @@
   DELETE1(num_thread_valid              , nb_thread);
 
-  return (EXIT_SUCCESS);
+  return (_return);
 }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/test.cpp	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/src/test.cpp	(revision 131)
@@ -7,9 +7,5 @@
  */
 
-#define NB_ITERATION  128
-#define CYCLE_MAX     (128*NB_ITERATION)
-
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/SelfTest/include/test.h"
-#include "Common/include/Test.h"
 #include "Behavioural/include/Allocation.h"
 
@@ -23,4 +19,6 @@
   morpheo::behavioural::Parameters_Statistics * _parameters_statistics = new morpheo::behavioural::Parameters_Statistics (5,CYCLE_MAX);
 #endif
+
+  _model.set_model(MODEL_SYSTEMC,true);
 
   Tusage_t _usage = USE_ALL;
@@ -60,4 +58,6 @@
   sc_signal<Ttype_t           >  **  in_EXECUTE_LOOP_IN_TYPE                 ;
   sc_signal<Tlsq_ptr_t        >  **  in_EXECUTE_LOOP_IN_STORE_QUEUE_PTR_WRITE;
+  sc_signal<Tlsq_ptr_t        >  **  in_EXECUTE_LOOP_IN_STORE_QUEUE_PTR_READ ;
+  sc_signal<Tcontrol_t        >  **  in_EXECUTE_LOOP_IN_STORE_QUEUE_EMPTY    ;
   sc_signal<Tlsq_ptr_t        >  **  in_EXECUTE_LOOP_IN_LOAD_QUEUE_PTR_WRITE ;
   sc_signal<Tcontrol_t        >  **  in_EXECUTE_LOOP_IN_HAS_IMMEDIAT         ;
@@ -125,4 +125,6 @@
   ALLOC1_SC_SIGNAL( in_EXECUTE_LOOP_IN_TYPE                 ," in_EXECUTE_LOOP_IN_TYPE                 ",Ttype_t           ,_param->_nb_read_unit);
   ALLOC1_SC_SIGNAL( in_EXECUTE_LOOP_IN_STORE_QUEUE_PTR_WRITE," in_EXECUTE_LOOP_IN_STORE_QUEUE_PTR_WRITE",Tlsq_ptr_t        ,_param->_nb_read_unit);
+  ALLOC1_SC_SIGNAL( in_EXECUTE_LOOP_IN_STORE_QUEUE_PTR_READ ," in_EXECUTE_LOOP_IN_STORE_QUEUE_PTR_READ ",Tlsq_ptr_t        ,_param->_nb_read_unit);
+  ALLOC1_SC_SIGNAL( in_EXECUTE_LOOP_IN_STORE_QUEUE_EMPTY    ," in_EXECUTE_LOOP_IN_STORE_QUEUE_EMPTY    ",Tcontrol_t        ,_param->_nb_read_unit);
   ALLOC1_SC_SIGNAL( in_EXECUTE_LOOP_IN_LOAD_QUEUE_PTR_WRITE ," in_EXECUTE_LOOP_IN_LOAD_QUEUE_PTR_WRITE ",Tlsq_ptr_t        ,_param->_nb_read_unit);
   ALLOC1_SC_SIGNAL( in_EXECUTE_LOOP_IN_HAS_IMMEDIAT         ," in_EXECUTE_LOOP_IN_HAS_IMMEDIAT         ",Tcontrol_t        ,_param->_nb_read_unit);
@@ -203,4 +205,6 @@
   INSTANCE1_SC_SIGNAL(_Execute_loop, in_EXECUTE_LOOP_IN_TYPE                 ,_param->_nb_read_unit);
   INSTANCE1_SC_SIGNAL(_Execute_loop, in_EXECUTE_LOOP_IN_STORE_QUEUE_PTR_WRITE,_param->_nb_read_unit);
+  INSTANCE1_SC_SIGNAL(_Execute_loop, in_EXECUTE_LOOP_IN_STORE_QUEUE_PTR_READ ,_param->_nb_read_unit);
+  INSTANCE1_SC_SIGNAL(_Execute_loop, in_EXECUTE_LOOP_IN_STORE_QUEUE_EMPTY    ,_param->_nb_read_unit);
   if (_param->_have_port_load_queue_ptr)
   INSTANCE1_SC_SIGNAL(_Execute_loop, in_EXECUTE_LOOP_IN_LOAD_QUEUE_PTR_WRITE ,_param->_nb_read_unit);
@@ -319,4 +323,6 @@
   DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_TYPE                 ,_param->_nb_read_unit);
   DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_STORE_QUEUE_PTR_WRITE,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_STORE_QUEUE_PTR_READ ,_param->_nb_read_unit);
+  DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_STORE_QUEUE_EMPTY    ,_param->_nb_read_unit);
   DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_LOAD_QUEUE_PTR_WRITE ,_param->_nb_read_unit);
   DELETE1_SC_SIGNAL( in_EXECUTE_LOOP_IN_HAS_IMMEDIAT         ,_param->_nb_read_unit);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/include/Context_State.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/include/Context_State.h	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/include/Context_State.h	(revision 131)
@@ -209,4 +209,5 @@
 					       
 #ifdef SYSTEMC				       
+  public  : void        constant                  (void);
   public  : void        transition                (void);
   public  : void        genMoore                  (void);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State.cpp	(revision 130)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State.cpp	(revision 131)
@@ -75,25 +75,16 @@
     if (usage_is_set(_usage,USE_SYSTEMC))
       {
-	// Constant 
-	for (uint32_t i=0; i<_param->_nb_context; i++)
-	  {
-	    internal_BRANCH_EVENT_ACK [i] = 1;
-	    PORT_WRITE(out_BRANCH_EVENT_ACK [i], internal_BRANCH_EVENT_ACK [i]);
-	  }
+#ifdef SYSTEMCASS_SPECIFIC
+        constant();
+#else
+	log_printf(INFO,Context_State,FUNCTION,_("Method - constant"));
 
-// 	for (uint32_t i=0; i<_param->_nb_decod_unit; i++)
-// 	  {
-// 	    internal_DECOD_EVENT_ACK [i] = 1;
-// 	    PORT_WRITE(out_DECOD_EVENT_ACK [i], internal_DECOD_EVENT_ACK [i]);
-// 	  }
-
-        internal_COMMIT_EVENT_ACK = 1;
-        PORT_WRITE(out_COMMIT_EVENT_ACK, internal_COMMIT_EVENT_ACK);
-
-	for (uint32_t i=0; i<_param->_nb_inst_branch_complete; i++)
-	  {
-	    internal_BRANCH_COMPLETE_ACK [i] = 1;
-	    PORT_WRITE(out_BRANCH_COMPLETE_ACK [i], internal_BRANCH_COMPLETE_ACK [i]);
-	  }
+	SC_METHOD (constant);
+// 	dont_initialize ();
+	
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+# endif    
+#endif
 
 	log_printf(INFO,Context_State,FUNCTION,_("Method - transition"));
